## erlang-sd notify-1.0

=== Makefile ===
REBAR ?= $(shell which rebar 2>/dev/null || which ./rebar)

REBAR_FLAGS ?=

all: compile

compile:
	$(REBAR) compile $(REBAR_FLAGS)

check: test
test: compile
	$(REBAR) eunit $(REBAR_FLAGS)

clean:
	$(REBAR) clean $(REBAR_FLAGS)

dialyzer:
	$(REBAR) dialyze $(REBAR_FLAGS)

deb:
	cd packaging/deb && $(MAKE) TOPDIR=$(PWD) deb

rpm: 
	cd packaging/centos && $(MAKE) TOPDIR=$(PWD) rpm

=== packaging/centos/Makefile ===
FINAL_OUTPUT_DIR=FINAL_RPMS



VERSION=1.0

# Directory names
RPM_BUILD_DIR=rpm-build
PKG_NAME=erlang-sd_notify
RPM_SOURCE_DIR=$(PKG_NAME)-$(VERSION)

TOP_DIR=$(shell pwd)

TARBALL_DIR=$(TOPDIR)
SOURCE_TGZ=$(PKG_NAME)-$(VERSION).tar.gz
TARGET_DIR=$(TARGET_TOP)/usr/lib/erlang/lib/sd_notify-$(VERSION)


DEFINES=--define '_topdir $(TOP_DIR)' --define '_tmppath $(TOP_DIR)/tmp' --define '_sysconfdir /etc' --define '_localstatedir /var'

rpm:	clean erlang-sd_notify

prepare:
	mkdir -p BUILD SOURCES SPECS SRPMS RPMS tmp dist $(TARBALL_DIR)
	tar czf $(TARBALL_DIR)/$(SOURCE_TGZ)  -C $(TOPDIR)  src/ c_src/ rebar.config LICENSE
	cp $(TOPDIR)/$(SOURCE_TGZ) SOURCES
	rm $(TOPDIR)/$(SOURCE_TGZ)
	cp erlang-sd_notify.spec SPECS

erlang-sd_notify: prepare
	mkdir -p $(FINAL_OUTPUT_DIR)
	rpmbuild -vvv -bb --nodeps SPECS/erlang-sd_notify.spec $(DEFINES)
	find RPMS -name "*.rpm" -exec sh -c 'mv {} `echo {} | sed 's#^RPMS\/noarch#$(FINAL_OUTPUT_DIR)#'`' ';'

clean:
	rm -rf BUILDROOT BUILD SOURCES SPECS SRPMS RPMS tmp $(FINAL_OUTPUT_DIR) dist

=== packaging/deb/Makefile ===
VERSION=1.0

# Directory names
DEB_BUILD_DIR=deb-build
PKG_NAME=erlang-sd-notify
DEB_SOURCE_DIR=$(PKG_NAME)-$(VERSION)

# 
PKG_DEST=$(TOPDIR)/$(DEB_BUILD_DIR)/$(DEB_SOURCE_DIR)

# Where to build the 'pristine' source files
TARBALL_DIR=$(TOPDIR)/$(DEB_BUILD_DIR)
SOURCE_TGZ=$(PKG_NAME)_$(VERSION).orig.tar.gz

# Place to install the compiled files to
TARGET_DIR=$(TARGET_TOP)/usr/lib/erlang/lib/sd_notify-$(VERSION)

deb:
	mkdir -p $(PKG_DEST)
	tar -c -C $(TOPDIR) --exclude-from=$(TOPDIR)/.gitignore --exclude=.git . | tar -x -C $(PKG_DEST)
	tar -zcf $(TARBALL_DIR)/$(SOURCE_TGZ) -C $(TARBALL_DIR) $(DEB_SOURCE_DIR)

	tar -c debian | tar -x -C $(PKG_DEST)
	cp $(TOPDIR)/LICENSE $(PKG_DEST)/debian/copyright
	sed -i 's/%VERSION%/$(VERSION)/g' $(PKG_DEST)/debian/$(PKG_NAME).dirs

	cd $(PKG_DEST) && debuild -us -uc

deb-install:
	pwd
	install -o root -g root -t $(TARGET_DIR)/ebin ../../ebin/*.app
	install -o root -g root -t $(TARGET_DIR)/ebin ../../ebin/*.beam
	install -o root -g root -t $(TARGET_DIR)/priv ../../priv/*.so

=== packaging/deb/debian/changelog ===
erlang-sd-notify (1.0-1) UNRELEASED; urgency=medium

  * Update for stub for NIF upgrade improvement 

 -- Gabriele Santomaggio <g.santomaggio@gmail.com>  Thu, 13 Apr 2017 11:54:18 +0000

=== packaging/deb/debian/control ===
Source: erlang-sd-notify
Maintainer: <g.santomaggio@gmail.com>
Section: misc
Priority: optional
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 9),
  erlang-dev (>=17.3-dfsg-4),
  libsystemd-dev (>=215),
  rebar,

Package: erlang-sd-notify
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
  erlang-base (>=17.3) | erlang-base-hipe (>=17.3),
  libsystemd0 (>=215),
Description: Systemd notification support for Erlang.
